/* misc.c - miscellaneous
 *      Copyright (C) 2002 Klarlvdalens Datakonsult AB
 *
 * This file is part of DirMngr.
 *
 * DirMngr is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * DirMngr is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <stdio.h>
#include <string.h>
#include "misc.h"
#include "error.h"

/* The ISO datetime format is YYYY-MM-DDTHH:MM:SS */

time_t iso_string2time( const char* str )
{
  struct tm _tm;
  memset( &_tm, 0, sizeof( struct tm ));
  /*log_debug( "read from %s\n", str);*/
  if( sscanf( str, "%d-%d-%dT%d:%d:%d", &(_tm.tm_year), &(_tm.tm_mon), 
	      &(_tm.tm_mday), &(_tm.tm_hour), &(_tm.tm_min), &(_tm.tm_sec) ) == 6 ) {
    _tm.tm_year -= 1900;
    /*
    log_debug( "year: %d\n", _tm.tm_year );
    log_debug( "mon : %d\n", _tm.tm_mon );
    log_debug( "day : %d\n", _tm.tm_mday );
    log_debug( "hour: %d\n", _tm.tm_hour );
    log_debug( "min : %d\n", _tm.tm_min );
    log_debug( "sec : %d\n", _tm.tm_sec );
    */
    return mktime( &_tm );
  } else {
    return -1;
  }
}

char*  iso_time2string( time_t t )
{
  static char buf[20];
  struct tm* _tm = gmtime( &t );
  if( _tm == NULL ) return NULL;
  /*log_debug( "writing %s\n", ctime( &t ) );*/
  _tm->tm_year += 1900;
  sprintf( buf, "%.4d-%.2d-%.2dT%.2d:%.2d:%.2d",(_tm->tm_year), (_tm->tm_mon), 
	   (_tm->tm_mday), (_tm->tm_hour), (_tm->tm_min), (_tm->tm_sec));
  return buf;
}
